#include <iostream>

using namespace std;

constexpr int MAXN = 21;
string s, t;
int n, d;
int ans = 0;
char dp[MAXN][MAXN];

int get_dist() {
    int m = t.size();
    for (int i = 0; i <= n; ++i) {
        dp[i][0] = i;
    }
    for (int j = 0; j <= m; ++j) {
        dp[0][j] = j;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            dp[i][j] = 1 + min(dp[i][j - 1], dp[i - 1][j]);
            dp[i][j] = min(dp[i][j], static_cast<char>((s[i - 1] == t[j - 1] ? 0  : 1) + dp[i - 1][j - 1]));
        }
    }

    return dp[n][m];
}

void gen(int idx) {
    int dist = get_dist();
    if (dist == d)
        ++ans;

    if (idx == n + d)
        return;

    for (char c = 'A'; c <= 'Z'; ++c) {
        t.push_back(c);
        gen(idx + 1);
        t.pop_back();
    }
}

int main() {
    cin >> s >> d;
    n = s.size();

    gen(0);

    cout << ans << '\n';

    return 0;
}
